<template lang="pug">
transition-group(@enter="onEnter" @leave="onLeave" css=false :appear="appear" :tag="tag")
  slot
</template>

<script>
import _ from 'lodash'
import Anim from './BaseAnimation'

/*
 * CSS animations are easier to achieve in an inline-block that has no
 * margins/padding, which is what this components does
 */
export default {
  name: 'BaseAnimationGroup',
  props: {
    tag: { type: String, default: 'span' },
    appear: { type: Boolean, default: true },
    animIn: { type: String, default: 'defaultIn' },
    animOut: { type: String, default: 'defaultOut' },
    options: { type: Object }
  },
  methods: {
    onEnter(elt, done) {
      elt = Anim.getDom(elt);
      var anim = _.defaultTo(elt.getAttribute('animIn'), this.animIn);
      if (_.isEmpty(anim)) { return done(); }
      _.invoke(Anim, anim, elt, this.options, done);
    },
    onLeave(elt, done) {
      elt = Anim.getDom(elt);
      var anim = _.defaultTo(elt.getAttribute('animOut'), this.animOut);
      if (_.isEmpty(anim)) { return done(); }
      _.invoke(Anim, anim, elt, this.options, done);
    }
  }
}
</script>

<style>
</style>
